package awais.instagrabber.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;

import awais.instagrabber.R;
import awais.instagrabber.adapters.viewholder.FollowsViewHolder;
import awais.instagrabber.models.FollowModel;
import awais.instagrabber.utils.Utils;

public class FollowsAdapter extends RecyclerView.Adapter<FollowsViewHolder> {
    private final ArrayList<FollowModel> followModels;
    private final View.OnClickListener clickListener;

    public FollowsAdapter(final ArrayList<FollowModel> followModels, final View.OnClickListener clickListener) {
        this.followModels = followModels;
        this.clickListener = clickListener;
    }

    @NonNull
    @Override
    public FollowsViewHolder onCreateViewHolder(@NonNull final ViewGroup parent, final int viewType) {
        return new FollowsViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.follow_item, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull final FollowsViewHolder holder, final int position) {
        final FollowModel followModel = followModels.get(position);
        if (followModel != null) {
            holder.itemView.setTag(followModel);
            holder.itemView.setOnClickListener(clickListener);

            holder.tvFullName.setText(followModel.getFullName());
            holder.tvUsername.setText(followModel.getUsername());

            Utils.PICASSO.load(followModel.getProfilePicUrl()).into(holder.profileImage);
        }
    }

    @Override
    public int getItemCount() {
        return followModels == null ? 0 : followModels.size();
    }
}
